<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleVendorAddressType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleVendorAddressType extends AbstractStructArrayBase
{
    /**
     * The CarCompanyAddress
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleVendorAddressType[]
     */
    public $CarCompanyAddress;
    /**
     * Constructor method for ArrayOfVehicleVendorAddressType
     * @uses DgArrayOfVehicleVendorAddressType::setCarCompanyAddress()
     * @param \dgsoft\StructType\DgVehicleVendorAddressType[] $carCompanyAddress
     */
    public function __construct(array $carCompanyAddress = array())
    {
        $this
            ->setCarCompanyAddress($carCompanyAddress);
    }
    /**
     * Get CarCompanyAddress value
     * @return \dgsoft\StructType\DgVehicleVendorAddressType[]|null
     */
    public function getCarCompanyAddress()
    {
        return $this->CarCompanyAddress;
    }
    /**
     * Set CarCompanyAddress value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleVendorAddressType[] $carCompanyAddress
     * @return \dgsoft\ArrayType\DgArrayOfVehicleVendorAddressType
     */
    public function setCarCompanyAddress(array $carCompanyAddress = array())
    {
        foreach ($carCompanyAddress as $arrayOfVehicleVendorAddressTypeCarCompanyAddressItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleVendorAddressTypeCarCompanyAddressItem instanceof \dgsoft\StructType\DgVehicleVendorAddressType) {
                throw new \InvalidArgumentException(sprintf('The CarCompanyAddress property can only contain items of \dgsoft\StructType\DgVehicleVendorAddressType, "%s" given', is_object($arrayOfVehicleVendorAddressTypeCarCompanyAddressItem) ? get_class($arrayOfVehicleVendorAddressTypeCarCompanyAddressItem) : gettype($arrayOfVehicleVendorAddressTypeCarCompanyAddressItem)), __LINE__);
            }
        }
        $this->CarCompanyAddress = $carCompanyAddress;
        return $this;
    }
    /**
     * Add item to CarCompanyAddress value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleVendorAddressType $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleVendorAddressType
     */
    public function addToCarCompanyAddress(\dgsoft\StructType\DgVehicleVendorAddressType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleVendorAddressType) {
            throw new \InvalidArgumentException(sprintf('The CarCompanyAddress property can only contain items of \dgsoft\StructType\DgVehicleVendorAddressType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CarCompanyAddress[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleVendorAddressType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleVendorAddressType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleVendorAddressType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleVendorAddressType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleVendorAddressType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CarCompanyAddress
     */
    public function getAttributeName()
    {
        return 'CarCompanyAddress';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleVendorAddressType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
